<?
/*
 * This file is part of the YateAdmin Project http://yateadmin.null.ro
 * A free web interface to set up a server based on the Yate telephony engine.
 * Copyright (C) 2006 Null Team
 *
 * Yet Another Telephony Engine - a fully featured software PBX and IVR
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 */
?>

<?
/*
** Allocate number ranges into YateAdmin
*/


$customer = getparam('customer');
$customer1 = getparam('customer1');
$line = getparam('line');
$change =  getparam('change');
$first = getparam('first');
$last = getparam('last');
$address = getparam('address');
$password = getparam('password');
$min = trim(getparam('minimum'));
$max = trim(getparam('maximum'));
$dom = getparam('domain');

loadbanner("Lines");

if ($method) {

	switch ($method)
	{
		case "check":
		{
			if (!checkRange($min,$max))
				break;
			$cnt = check($min,$max);
			if ($cnt) {
				message("There are $cnt lines in range $min - $max",$path);
			break;
			}
			else {
				message("There aren't any lines in range $min - $max",$path);
				break;;
			}
			break;
		}

		case "findelline":
			findelline($line);
			break;
		case "findel":
			findel($min,$max);
			break;
		case "add":
		{
			if (!checkRange($min,$max))
				break;
			$cnt = check($min,$max);
			if ($cnt) {
				message("There are already $cnt lines in range $min - $max",$path);
				break;
			}
			if (!add($min,$max,$customer1))
				break;
			break;
		}
		case "del":
		{
			if (!checkRange($min,$max))
				break;
			del($min,$max);
			break;
		}
		case "delline":
			delline($line);
		break;
		case "show":
		{
			if (!checkRange($min,$max))
				break;
			show($min,$max);
			break;
		}
		case "edit":
			edit($line);
			break;
		case "addline":
			addline($line,$customer);
			break;
	}
} else {
?>
<form action="main.php" method="post">
	<input type="hidden" name="module" value="lines"/>
	<table class="mass">
		<tr class="mass">
				<th class="mass" > <br/>Operations with range of lines </th>
		</tr>
		</tr>
		<tr>
				<td class="mass">
					<table class="vertical">
						<tr>
							<th class="vertical">Number range </th>
							<th class="vertical">from </th> <td> <input type="text" name="minimum" size="4" value="<? print $min;?>" /></td>

							<th class="vertical">to</th><td><input type="text" name="maximum" size="4" value="<? print $max;?>" /></td>
						</tr>
					</table>
					<input type="radio" name="method" value="check"/> Check if free<br/>
					<input type="radio" name="method" value="show"/> Show lines in range<br/>
					<input type="radio" name="method" value="add"/> Add <br/>
					<input type="radio" name="method" value="del"/> Delete lines (use with care!)

				</td>
		</tr>
		<tr>
				<th class="mass"><br/> Operations with single line </th>
		</tr>
		<tr>
				<td class="mass">
					<table class="vertical">
						<tr>
							<th class="vertical"> Insert line </th>
							<td> <input type="text" name="line" size="4" /> </td>
						</tr>
					</table>
					<input type="radio" name="method" value="addline"/> Add <br/>
					<input type="radio" name="method" value="edit"/> Edit<br/>
					<input type="radio" name="method" value="delline"> Delete (use with care!)
					</br><br/>
				</td>
			</tr>
	</table>
	<input type="submit" value="Execute"/>
</form>
<br/>
NOTE!! <br/>
For operations with a range of lines don't forget that the "from" line and the "to" line must have the same number of digits. For example from '000' to '999' or from '7260000' to '7269999'.
<?
}


function addline($line)
{
	global $conn,$path;
	if (!$line)
		return false;
	$query = "SELECT line FROM lines WHERE line='$line'";
	$res = pg_exec($conn,$query);
	if (pg_num_rows($res))
	{
		message("This line is already assigned to a user",$path);
		return false;
	}

	$query = "INSERT into lines (line) VALUES ('$line')";
	$res = pg_exec($conn,$query);
	if (!$res || pg_affected_rows($res)<1)
	{
		message("Failed to insert new line");
		return false;
	}
	print ("Line $line was added");
	edit($line);
	return true;
}

function edit($line)
{
	global $conn,$path,$change,$first,$last,$address,$password;
	if (!$line) {
		print ("Please insert line");
		return false;
	}
	$query = "SELECT first_name,last_name,address,password FROM lines WHERE line='$line'";
	$res = pg_exec($conn,$query);
	if (!$res || pg_num_rows($res)==0)
	{
		message("This line was not added",$path);
		return false;
	}
	if (!$change)
	{
		?>
		<form action="main.php">
			<input type="hidden" name="module" value="lines"/>
			<input type="hidden" name="method" value="edit"/>
			<br/>
			Edit line <? print $line; ?> <br/><br/>
			<table class="vertical">
				<tr>
					<th class="vertical"> Password</th>
					<td class="vertical"> <input type="text" name="password" value="<? print pg_fetch_result($res,0,3);?>" size="10"/></td>
				</tr>
				<tr>
					<th class="vertical">
						First
					</th>
					<td class="vertical">
						<input type="text" name="first" value="<? print pg_fetch_result($res,0,0); ?>" size="10"/>
					</td>
				</tr>
				<tr>
					<th class="vertical">
						Last
					</th>
					<td class="vertical">
						<input type="text" name="last" value="<? print pg_fetch_result($res,0,1); ?>" size="10"/>
					</td>
				</tr>
				<tr>
					<th class="vertical">
						Address
					</th>
					<td class="vertical">
						<input type="text" name="address" value="<? print pg_fetch_result($res,0,2); ?>" size="10">
					</td>
				</tr>

			</table>
			<input type="hidden" name="line" value="<? print $line;?>"/>
			<input type="hidden" name="change" value="change"/>
			<br/>
			<table>
				<tr>
					<td> <input type="submit" value="Save"/></td>
					<td> <input type="reset" value="Clear" /> </td>
				</tr>
			</table>
		    </form>
<?
	}
	else
	{
		$query = "UPDATE lines SET password='$password', first_name='$first', last_name='$last', address='$address' WHERE line='$line'";
		$res = pg_exec($conn,$query);
		if (!$res || pg_affected_rows($res)<1)
		{
			message("Failed updating information about line $line",$path);
		}
		else
		message ("Updated information about line $line",$path);
	}
}

function add($min,$max)
{
    global $conn,$path;
	$fmt = "%0" . strlen($max) . "d";
		for ($i=$min;$i<=$max;$i++)
		{
			$n = sprintf($fmt,$i);
			$query="INSERT INTO lines (line) VALUES ('$n') ";
			$res=pg_exec($conn,$query);
			if (!$res)
			{
				die("Failed inserting into lines");
				return false;
			}

		}
		message("Added lines from $min to $max ",$path);
		return true;
}

function checkRange($min,$max)
{
    global $path;
    if (is_numeric($min) && is_numeric($max) && (strlen($min) == strlen($max)) && ($min <= $max) && ($min >= 0))
		return true;
    message("Invalid number range $min - $max",$path);
    return false;
}

function del($min,$max)
{
	global $conn;
	$query = "SELECT count(*) FROM lines WHERE  line>='$min' AND line<='$max'";
	$res = pg_exec($conn,$query);
	$nr = pg_fetch_result($res,0,0);
	?> <br/> <?

	print ("There are $nr of lines in range $min-$max. Are you sure you want to delete them?");
	?>
	<br/> <br/>
	<table>
	<tr>
		<td>
			<form action="main.php" method="post">
				<input type="hidden" name="module" value="lines"/>
				<input type="hidden" name="method" value="findel"/>
				<input type="hidden" name="minimum" value="<? print $min;?>"/>
				<input type="hidden" name="maximum" value="<? print $max;?>"/>
				<input type="submit" value="Yes"/>
			</form>
		</td>
		<td>
			<form action="main.php?" method="post">
				<input type="hidden" name="module" value="lines"/>
				<input type="submit" value=" No "/>
			</form>
		</td>
	</tr>
</table>
<?
}

function findel($min,$max)
{
    global $conn,$path;
    $len = strlen($max);

    $query = "DELETE FROM lines WHERE line>='$min' AND line<='$max'";
    $res = pg_query($conn,$query);
    if ($res)
	{
		$res = pg_affected_rows($res);
		message("Deleted $res lines in range $min - $max",$path);
    }
    else
		message("Failed to delete line range!",$path);
}

function delline($line)
{
	global $conn;
?> <br/> <?
	print ("Are yoy sure you want to delete line $line?");
	?>
	<br/>
	<table>
	<tr>
		<td>
			<form action="main.php" method="post">
				<input type="hidden" name="module" value="lines"/>
				<input type="hidden" name="method" value="findelline"/>
				<input type="hidden" name="line" value="<? print $line;?>"/>
				<input type="submit" value="Yes"/>
			</form>
		</td>
		<td>
			<form action="main.php?" method="post">
				<input type="hidden" name="module" value="lines"/>
				<input type="submit" value=" No "/>
			</form>
		</td>
	</tr>
</table>
<?
}

function findelline($line)
{
	global $conn;
	$query = "DELETE FROM lines WHERE line='$line'";
	$res = pg_exec($conn,$query);
}

function show($min,$max)
{
    global $conn;
    $len = strlen($max);
    $query = "SELECT lines.line,lines.first_name,lines.last_name FROM lines WHERE line>='$min' AND line<='$max' AND char_length(line) = $len ORDER by lines.line";
    $res = pg_exec($conn,$query);
    ?>
		<br/>
		<div align="right" class="content"><a href="main.php?module=lines">Back</a></div>
		<table class="content">
			<tr>
				<th class="content">Line</th>
				<th class="content">Firstname</th>
				<th class="content">Lastname</th>
			</tr>

    <?
    for ($i=0;$i<pg_num_rows($res);$i++)
    {
    ?>
			<tr>
				<td class="content">&nbsp;<? print pg_fetch_result($res,$i,0);?></td>
				<td class="content">&nbsp;<? print pg_fetch_result($res,$i,1);?></td>
				<td class="content">&nbsp;<? print pg_fetch_result($res,$i,2);?></td>
			</tr>
    <?
    }
    ?>

    </table>
    <?
}

function check($min,$max)
{
    global $conn;
    $len = strlen($max);
    $query = "SELECT COUNT(line) FROM lines WHERE line>='$min' AND line<='$max' AND char_length(line)=$len";
    $res = pg_query($conn,$query);
    if ($res && pg_num_rows($res))
		return pg_fetch_result($res,0,0);
    return 0;
}


/* vi: set ts=8 sw=4 sts=4 noet: */
?>
